2016弱校联萌十一专场10.2

F.floyd-warshell

20000个点,距离为1的所有边求最短路

感觉就是单纯的生成树求最短路(最近公共祖先)

然后把去掉的边还原

把涉及的点bfs一下拼出最短路

#include<cstdio>
#include<algorithm>
#include<cstring>
#define F(i,a,b) for(int i=a;i<=b;i++)
#define mst(a,b) memset(a,b,sizeof(a))
using namespace std;
typedef pair<int,int>P;

const int N=1e5+200,DEG=18;
int g[N],v[N*2],nxt[N*2],ed,n,m,q,eed,cnt,id[N],Q[N];
int dep[N],fa[N][DEG],dfn[N],idx,d[201][N];
P vec[N];
bool vis[N];

inline void adg(int x,int y){v[++ed]=y,nxt[ed]=g[x],g[x]=ed;}
inline void up(int &a,int b){if(a>b)a=b;}

void dfs(int u=1,int pre=0)
{
    dep[u]=dep[pre]+1,fa[u][0]=pre,dfn[u]=++idx;
    F(i,1,DEG-1)fa[u][i]=fa[fa[u][i-1]][i-1];
    for(int i=g[u];i;i=nxt[i])if(!dfn[v[i]])dfs(v[i],u);
    else if(v[i]!=pre&&dfn[v[i]]<dfn[u])vec[++eed]=P(u,v[i]);
}

int LCA(int a,int b){
    if(dep[a]>dep[b])a^=b,b^=a,a^=b;
    if(dep[a]<dep[b])F(i,0,DEG-1)if((dep[b]-dep[a])&(1<<i))b=fa[b][i];
    if(a!=b)for(int i=DEG-1;i<0?a=fa[a][0]:0,i>=0;i--)
    if(fa[a][i]!=fa[b][i])a=fa[a][i],b=fa[b][i];
    return a;
}

void bfs(int *d,int S)
{
    mst(vis,0);
    int head=1,tail=0,now;
    Q[++tail]=S,vis[S]=1,d[S]=0;
    while(head<=tail)for(int i=g[now=Q[head++]];i;i=nxt[i])
    if(!vis[v[i]])vis[v[i]]=1,d[v[i]]=d[now]+1,Q[++tail]=v[i];
}

int main()
{
    while(~scanf("%d%d%d",&n,&m,&q))
    {
        int x,y;ed=idx=eed=cnt=0;
        mst(g,0),mst(dfn,0),mst(fa,0),mst(id,0);
        F(i,1,m)scanf("%d%d",&x,&y),adg(x,y),adg(y,x);
        dfs();
        F(i,1,eed)
        {
            if(!id[vec[i].first])id[vec[i].first]=++cnt,bfs(d[cnt],vec[i].first);
            if(!id[vec[i].second])id[vec[i].second]=++cnt,bfs(d[cnt],vec[i].second);
        }
        F(i,1,q)
        {
            scanf("%d%d",&x,&y);
            int ans=dep[x]+dep[y]-2*dep[LCA(x,y)];
            F(j,1,eed)
            {
                int u=id[vec[j].first],v=id[vec[j].second];
                up(ans,d[u][x]+d[v][y]+1),up(ans,d[v][x]+d[u][y]+1);
            }
            printf("%d\n",ans);
        }
    }
    return 0;
}

H.around the world

规律性还很强的,莽一波+阶乘一波AC

首先把所有少点的树边数都置2,莽一波,走一遍路就知道方案数的规律

叶子结点方案数1

在本层求出走过下面所有(子树的方案数*2)之积*(子树数量!)

再把一些边2个2个地加,会发现方案数有规律性地涨

由于一些边超过2,走的路径也会带来不规则的变化

比如1->2->3,若是2->3加2条边会*c(5,1)

若是1->2加2条边会*c(5,3)

会发现其实是满足c(t1+t2-1,t1-1)的

#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <string.h>
typedef long long LL;
const LL maxn=1e5+10;
const LL mod=1e9+7;
using namespace std;
struct Tree
{
    LL to,next,c;
} edge[maxn*2];
LL Inv[30*maxn];
LL tot,head[maxn];
LL jc[maxn*30];
LL sum;
void Init()
{
    Inv[0]=1;
    Inv[1] = 1;
    for(LL i=2; i<25*maxn; i++)
        Inv[i] = (mod-mod/i)*Inv[mod%i]%mod;
    for(LL i=2; i<25*maxn; i++)
        Inv[i] = (Inv[i-1]*Inv[i])%mod;
}
void init()
{
    tot=0;
    memset(head,-1,sizeof(head));
}
void add_edge(LL u,LL v,LL c)
{
    edge[tot].to=v;
    edge[tot].c=c;
    edge[tot].next=head[u];
    head[u]=tot++;
}

void init2()
{
    jc[0]=1;
    for(LL i=1; i<maxn*30; i++)
        jc[i]=((jc[i-1]*i)%mod);
}
LL road[maxn];
void  dfs(LL u,LL pre)
{
    road[u]=0;
    for(LL i=head[u]; i!=-1; i=edge[i].next)
    {
        LL v=edge[i].to;
        if(v==pre) continue;
        dfs(v,u);
        road[u]+=edge[i].c;
        sum=(((sum*jc[edge[i].c*2])%mod)*Inv[edge[i].c])%mod;
        sum=((sum*  jc[(road[v]+edge[i].c-1)]%mod)*Inv[edge[i].c-1] )%mod;
        sum=(sum*Inv[road[v]])%mod;
    }
    sum=(sum*jc[road[u]])%mod;
}

int main()
{
    Init();
    init2();
    LL n,u,v,c;
    while(scanf("%lld",&n)!=-1)
    {
        sum=1;
        init();
        for(LL i=1; i<n; i++)
        {
            scanf("%lld%lld%lld",&u,&v,&c);
            add_edge(u,v,c);
            add_edge(v,u,c);
        }
        dfs(1,0);
        printf("%lld\n",sum);
    }
    return 0;
}

时间: 2024-11-12 09:22:34

2016弱校联萌十一专场10.2的相关文章

2016弱校联萌十一专场10.3 遗憾题合集

http://acm-icpc.aitea.net/index.php?2016%2FPractice%2F%E6%A8%A1%E6%93%AC%E5%9C%B0%E5%8C%BA%E4%BA%88%E9%81%B8%2F%E8%AC%9B%E8%A9%95 C.We don't wanna work! @siludose 你要的代码,做好了参考看 SB模拟,xjb模拟 #include <iostream> #include <algorithm> #include <st

2016弱校联萌十一专场10.5

A. 因为字符串不可以交叉,其实容易解 把不同字符的可用区域看成一个区间,用类似于链表的方法连接起来 查询的就是查询到的链表数量/4(当然右区间必须属于y) 区间查询用倍增或线段树都可以 //倍增 #include <cstdio> #include <cstring> char s[100005]; int m, n, pe, pa, ps, py, dep; int pre[100005], ed[100005]; int fa[100005][20]; int main()

西南弱校联萌(1)

A. 垃圾题目毁我青春(3n+1猜想 || 模拟) Sample Input 5 Sample Output YES Hint 对于样例1:1 -> 2 -> 4 -> 8 -> 16 -> 5 Solve: 可以直接从n模拟(模拟就变成了3*n+1猜想了),所以很明显他是都是yes的 Code: 1 #pragma comment(linker, "/STACK:36777216") 2 3 #include <bits/stdc++.h>

(2016弱校联盟十一专场10.3) A.Best Matched Pair

题目链接 #include<cstdio> #include<cstring> #include<algorithm> #include<stack> using namespace std; int n,data[1005]; int cal(int x) { int tx=x; int pre=-1; while(tx) { if(pre!=-1&&tx%10-pre!=-1) return -1; pre = tx%10; tx/=10

2016弱校联盟十一专场10.3---Similarity of Subtrees(深搜+hash、映射)

题目链接 https://acm.bnu.edu.cn/v3/problem_show.php?pid=52310 problem description Define the depth of a node in a rooted tree by applying the following rules recursively: • The depth of a root node is 0. • The depths of child nodes whose parents are with

2016弱校联盟十一专场10.2---Around the World(深搜+组合数、逆元)

题目链接 https://acm.bnu.edu.cn/v3/problem_show.php?pid=52305 problem  description In ICPCCamp, there are n cities and (n−1) (bidirectional) roads between cities. The i-th road is between the ai-th and bi-th cities. It is guaranteed that cities are conne

2016弱校联盟十一专场10.2——Around the World

题目链接:Around the World 题意: 给你n个点,有n-1条边,现在这n-1条边又多增加了ci*2-1条边,问你有多少条欧拉回路 题解: 套用best定理 Best Theorem:有向图中以 i 为起点的欧拉回路个数为以 i 为根的树形图个数 ×(( 每个点 度数 −1)!). Matrix Tree Theorem:以 i 为根的树形图个数 = 基尔霍夫矩阵去掉第 i 行第 i 列的行列 式. 从某个点 i 出发并回到 i 的欧拉回路个数 = 以 i 为起点的欧拉回路个数 ×i

2016弱校联盟十一专场10.2部分题解

1/10 J. Matrix Transformation 1 /*zhen hao*/ 2 #include <bits/stdc++.h> 3 using namespace std; 4 5 #define lson l, m, rt*2 6 #define rson m + 1, r, rt*2+1 7 #define xx first 8 #define yy second 9 10 typedef long long LL; 11 typedef unsigned long lon

2016弱校联盟十一专场10.2——Floyd-Warshall

题目链接:Floyd-Warshall 题意: 给你n个点,m条边,100>m-n>0,现在有q个询问,问你任意两点的最短距离,题目保证每条边都被连接,每条边的距离为1 题解: 首先我们可以看到边最多只比点多100个,那么我们可以先将n-1条边生成一棵树,然后用LCA来求最短距离. 然而有可能最短路在多余的这100条边上,所以我们将这100条边的两个端点到所有点的最短路用bfs预处理出来, 然后再用来更新一下答案就行. 1 #include<cstdio> 2 #include&l